package com.winsun.controller;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.winsun.auth.core.annotion.Permission;
import com.winsun.auth.core.base.controller.BaseController;
import com.winsun.auth.core.common.model.ResponseData;
import com.winsun.bean.Teacher;
import com.winsun.interfaces.PermissionVerification;
import com.winsun.mapper.TeacherMapper;
import com.winsun.mapper.TeacherMapper;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @Date: 2021/1/14
 */
@RestController
@RequestMapping("/teacher")
public class TeacherController extends BaseController {

    @Autowired
    private TeacherMapper teacherMapper;

    @PermissionVerification(value = {"/school-center/broadbandList/teacher"})
    @Permission(menuname = "查询信息", value = "list", method = RequestMethod.POST)
    public Map<String,Object> dataList(@RequestParam(name = "id",required = false)String id,
                                       @RequestParam(name = "stuNumber",required = false)String stuNumber,
                                       @RequestParam(name = "stuName",required = false)String stuName,
                                       @RequestParam(name = "pageNo", required = false) int pageNo,
                                       @RequestParam(name = "pageSize", required = false) int pageSize
    ){
        Map<String,Object> map = new HashMap<>();
        Wrapper<Teacher> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id",id);
        wrapper.eq(StringUtils.isNotBlank(stuNumber), "student_number",stuNumber);
        wrapper.eq(StringUtils.isNotBlank(stuName), "student_name",stuName);
        List<String> objects = new ArrayList<>();
        objects.add("id");
        wrapper.orderDesc(objects);
        Page<Teacher> page = new Page<>(pageNo, pageSize);
        List<Teacher> aPackage = teacherMapper.selectPage(page, wrapper);
        page.setRecords(aPackage);
        map.put("page",ResponseData.success(page,"查询成功！"));
        return map;
    }

    @PermissionVerification(value = {"/school-center/broadbandList/teacher"})
    @Permission(menuname = "新增信息", value = "addData",method = RequestMethod.POST)
    public ResponseData<String> addData(@RequestParam(name = "stuNumber") String stuNumber,
                                        @RequestParam(name = "stuName") String stuName){
        Wrapper<Teacher> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(stuNumber), "student_number",stuNumber);
        List<Teacher> list = teacherMapper.selectList(wrapper);
        if(list != null && list.size()>0){
            return ResponseData.error("教师工号已存在！");
        }
        Teacher teacher = new Teacher();
        teacher.setStuNumber(stuNumber);
        teacher.setStuName(stuName);
        try {
            teacherMapper.insert(teacher);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }

    @PermissionVerification(value = {"/school-center/broadbandList/teacher"})
    @Permission(menuname = "删除信息", value = "deleteData",method = RequestMethod.POST)
    public ResponseData<String> deleteData(@RequestParam(name = "id") String id){
        if(StringUtils.isBlank(id)){
            return ResponseData.error("");
        };
        Wrapper<Teacher> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id",id);
        try {
            teacherMapper.delete(wrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }
}
